 '*****************************************************************************************************************
'*  Name    : I2CPrintHardCommand_Demo.bas                                                                       *
'*  Purpose : Demonstrate the replacement Print routine For I2C backback On std alpha LCD                        * 
'*  Author  : George Towler                                                                                      *
'*  Notice  : I claim no copyright but maybe Barak does                                                          *
'*  Date    : 29/08/2014                                                                                         *
'*  Version : 0.4.0                                                                                              *
'*  Notes   : see http://www.protonbasic.co.uk/showthread.php/62478-%93Print%94-command-for-SPI-Alfa-numeric-LCD *                                                  *
'*          :     post #6   Barak shows how to replace Proton commands and how to deal with control (FE$) bytes  *                                          *                                                                                     *
'*****************************************************************************************************************
'History 0.4.0 - changed test data to demonstrate double char "fix"
'        0.3.1 - changed test data to demonstrate double char problem
'        0.3.0 - changed test data 
'        0.2.0 - "working" parts of program removed To Include file 

  Device = 18F4550

  Declare Create_Coff = On      ; for Proteus 8
  Xtal = 48
  All_Digital = True

  ' Setup the LCD. These must be included in the program
  ' Note! I2C is generated by MSSP so SDA\SCL pins are fixed for each PIC 

  ' Define I2C bus ports
  'Declare SDA_Pin = PORTB.0 
  'Declare SCL_Pin = PORTB.1 
  Declare Slow_Bus Off
  Declare Hbus_Bitrate 400

  ' Define PRINT paramaters
  Declare LCD_Interface = 4
  Declare LCD_Lines = 2
  Declare LCD_Type = Alphanumeric
  Declare LCD_CommandUs = 2000
  Declare LCD_DataUs = 50

  Include "I2CPrintHardCommand_P61.inc"     ' you may need to select alternate config depending on your backpack

  Dim ForCount As Byte
  Dim MyToggle As Byte
'------------------------------------------------------------------------------------------------
Main:
  DelayMS 30                        ' Wait for the LCD to initialise
  Cls
  DelayMS 50
  Print At 1,1,"Loop"  
  DelayMS 500  
  Print $FE, 1                      ' clear display 
  Print At 1,1,"22"
  DelayMS 500  
  Print $FE, 1                      ' clear display 
  Print At 1,1,"222"
  DelayMS 500  
  Print $FE, 1                      ' clear display 
  Print At 1,1,"oooo"
  DelayMS 500  
  Print $FE, 1                      ' clear display  
  Print At 1,1,"xxxxx"  
  DelayMS 500  
  Print $FE, 1                      ' clear display 
  Print At 1,1,"xxxxxx"  
  DelayMS 500  
  Print $FE, 1                      ' clear display 
  Print $FE, $0E                    ' curor on  
  MyToggle = 0
Loop:
    MyToggle = ~MyToggle
    If MyToggle = 0 Then
      Print $FE, 3                  ' backlight on  
    Else                            
      Print $FE, 4                  ' backlight off  
    EndIf

  For ForCount = 1 To 10
    Print At 1,1,"The quick blue"
    Print At 1,15,Dec ForCount
    DelayMS 100
    Print At 2,1,"  JJumped over"
    Print At 2,15,Dec ForCount
    DelayMS 100
  Next
  Cls
  DelayMS 500
  GoTo Loop  


  Config_Start
    PLLDIV = 5            ;Divide by 5 (20 MHz oscillator input)
    CPUDIV = OSC1_PLL2    ;[Primary Oscillator Src: /1][96 MHz PLL Src: /2]
    USBDIV = 2            ;USB clock source comes from the 96 MHz PLL divided by 2
    FOSC = HSPLL_HS       ;HS oscillator, PLL enabled (HSPLL)
    FCMEN = OFF           ;Fail-Safe Clock Monitor disabled
    IESO = OFF            ;Oscillator Switchover mode disabled
    PWRT = On             ;PWRT enabled
    BOR = On              ;Brown-out Reset enabled in hardware only (SBOREN is disabled)
    BORV = 3              ;Minimum setting
    VREGEN = OFF          ;USB voltage regulator disabled
    WDT = OFF             ;WDT disabled (control is placed on the SWDTEN bit)
    WDTPS = 32768         ;1:32768
    CCP2MX = OFF          ;CCP2 input/output is multiplexed with RB3
    PBADEN = OFF          ;PORTB<4:0> pins are configured as digital I/O on Reset
    LPT1OSC = OFF         ;Timer1 configured for higher power operation
    MCLRE = On            ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On           ;Stack full/underflow will cause Reset
    LVP = OFF             ;Single-Supply ICSP disabled
    ICPRT = OFF           ;ICPORT disabled
    XINST = OFF           ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF           ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF             ;Block 0 (000800-001FFFh) is not code-protected
    CP1 = OFF             ;Block 1 (002000-003FFFh) is not code-protected
    CP2 = OFF             ;Block 2 (004000-005FFFh) is not code-protected
    CP3 = OFF             ;Block 3 (006000-007FFFh) is not code-protected
    CPB = OFF             ;Boot block (000000-0007FFh) is not code-protected
    CPD = OFF             ;Data EEPROM is not code-protected
    WRT0 = OFF            ;Block 0 (000800-001FFFh) is not write-protected
    WRT1 = OFF            ;Block 1 (002000-003FFFh) is not write-protected
    WRT2 = OFF            ;Block 2 (004000-005FFFh) is not write-protected
    WRT3 = OFF            ;Block 3 (006000-007FFFh) is not write-protected
    WRTC = OFF            ;Configuration registers (300000-3000FFh) are not write-protected
    WRTB = OFF            ;Boot block (000000-0007FFh) is not write-protected
    WRTD = OFF            ;Data EEPROM is not write-protected
    EBTR0 = OFF           ;Block 0 (000800-001FFFh) is not protected from table reads executed in other blocks
    EBTR1 = OFF           ;Block 1 (002000-003FFFh) is not protected from table reads executed in other blocks
    EBTR2 = OFF           ;Block 2 (004000-005FFFh) is not protected from table reads executed in other blocks
    EBTR3 = OFF           ;Block 3 (006000-007FFFh) is not protected from table reads executed in other blocks
    EBTRB = OFF           ;Boot block (000000-0007FFh) is not protected from table reads executed in other blocks
  Config_End
